src/Entity/Client.php
<?php

namespace App\Entity;

use App\Repository\ClientRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=ClientRepository::class)
 */
class Client
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private $Nom;

    /**
     * @ORM\Column(type="string", length=50)
     */
    private $Prenom;

    /**
     * @ORM\Column(type="string", length=20)
     */
    private $Telephone;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Email;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Adresse;

    /**
     * @ORM\Column(type="boolean")
     */
    private $Accord;

    /**
     * @ORM\OneToMany(targetEntity=Location::class, mappedBy="Client")
     */
    private $locations;

    /**
     * @ORM\OneToMany(targetEntity=Facturation::class, mappedBy="Client")
     */
    private $facturations;

    public function __construct()
    {
        $this->locations = new ArrayCollection();
        $this->facturations = new ArrayCollection();
    }

    public function __toString(): string
    {
        return $this->getNom();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNom(): ?string
    {
        return $this->Nom;
    }

    public function setNom(string $Nom): self
    {
        $this->Nom = $Nom;

        return $this;
    }

    public function getPrenom(): ?string
    {
        return $this->Prenom;
    }

    public function setPrenom(string $Prenom): self
    {
        $this->Prenom = $Prenom;

        return $this;
    }

    public function getTelephone(): ?string
    {
        return $this->Telephone;
    }

    public function setTelephone(string $Telephone): self
    {
        $this->Telephone = $Telephone;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->Email;
    }

    public function setEmail(string $Email): self
    {
        $this->Email = $Email;

        return $this;
    }

    public function getAdresse(): ?string
    {
        return $this->Adresse;
    }

    public function setAdresse(string $Adresse): self
    {
        $this->Adresse = $Adresse;

        return $this;
    }

    public function getAccord(): ?bool
    {
        return $this->Accord;
    }

    public function setAccord(bool $Accord): self
    {
        $this->Accord = $Accord;

        return $this;
    }

    /**
     * @return Collection|Location[]
     */
    public function getLocations(): Collection
    {
        return $this->locations;
    }

    public function addLocation(Location $location): self
    {
        if (!$this->locations->contains($location)) {
            $this->locations[] = $location;
            $location->setClient($this);
        }

        return $this;
    }

    public function removeLocation(Location $location): self
    {
        if ($this->locations->removeElement($location)) {
            // set the owning side to null (unless already changed)
            if ($location->getClient() === $this) {
                $location->setClient(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection|Facturation[]
     */
    public function getFacturations(): Collection
    {
        return $this->facturations;
    }

    public function addFacturation(Facturation $facturation): self
    {
        if (!$this->facturations->contains($facturation)) {
            $this->facturations[] = $facturation;
            $facturation->setClient($this);
        }

        return $this;
    }

    public function removeFacturation(Facturation $facturation): self
    {
        if ($this->facturations->removeElement($facturation)) {
            // set the owning side to null (unless already changed)
            if ($facturation->getClient() === $this) {
                $facturation->setClient(null);
            }
        }

        return $this;
    }
}

src/Entity/LigneFacturation.php
<?php

namespace App\Entity;

use App\Repository\LigneFacturationRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=LigneFacturationRepository::class)
 */
class LigneFacturation
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=150)
     */
    private $Libelle;

    /**
     * @ORM\Column(type="float")
     */
    private $Prix;

    /**
     * @ORM\Column(type="integer")
     */
    private $Reference;

    /**
     * @ORM\ManyToOne(targetEntity=Facturation::class, inversedBy="ligneFacturations", cascade={"persist", "remove"})
     */
    private $Facture;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLibelle(): ?string
    {
        return $this->Libelle;
    }

    public function setLibelle(string $Libelle): self
    {
        $this->Libelle = $Libelle;

        return $this;
    }

    public function getPrix(): ?float
    {
        return $this->Prix;
    }

    public function setPrix(float $Prix): self
    {
        $this->Prix = $Prix;

        return $this;
    }

    public function getReference(): ?int
    {
        return $this->Reference;
    }

    public function setReference(int $Reference): self
    {
        $this->Reference = $Reference;

        return $this;
    }

    public function getFacture(): ?Facturation
    {
        return $this->Facture;
    }

    public function setFacture(?Facturation $Facture): self
    {
        $this->Facture = $Facture;

        return $this;
    }
}

src/Entity/TypeBien.php
<?php

namespace App\Entity;

use App\Repository\TypeBienRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=TypeBienRepository::class)
 */
class TypeBien
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=150)
     */
    private $Label;

    /**
     * @ORM\Column(type="integer")
     */
    private $Prix;

    /**
     * @ORM\OneToMany(targetEntity=Bien::class, mappedBy="Type")
     */
    private $biens;

    public function __construct()
    {
        $this->biens = new ArrayCollection();
    }

    public function __toString(): string
    {
        return $this->getLabel();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getLabel(): ?string
    {
        return $this->Label;
    }

    public function setLabel(string $Label): self
    {
        $this->Label = $Label;

        return $this;
    }

    public function getPrix(): ?int
    {
        return $this->Prix;
    }

    public function setPrix(int $Prix): self
    {
        $this->Prix = $Prix;

        return $this;
    }

    /**
     * @return Collection|Bien[]
     */
    public function getBiens(): Collection
    {
        return $this->biens;
    }

    public function addBien(Bien $bien): self
    {
        if (!$this->biens->contains($bien)) {
            $this->biens[] = $bien;
            $bien->setType($this);
        }

        return $this;
    }

    public function removeBien(Bien $bien): self
    {
        if ($this->biens->removeElement($bien)) {
            // set the owning side to null (unless already changed)
            if ($bien->getType() === $this) {
                $bien->setType(null);
            }
        }

        return $this;
    }
}

src/Controller/HomeController.php
<?php

namespace App\Controller;

use App\Entity\Client;
use App\Entity\Facturation;
use App\Entity\LigneFacturation;
use App\Entity\Location;
use App\Entity\Tarif;
use App\Form\BienType;
use App\Form\LocationType;
use App\Repository\BienRepository;
use App\Repository\ClientRepository;
use App\Repository\FacturationRepository;
use App\Repository\LigneFacturationRepository;
use App\Repository\LocationRepository;
use DateTime;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Mailer\MailerInterface;
use Symfony\Component\Mime\Address;
use Symfony\Component\Mime\Email;
use Symfony\Component\Routing\Annotation\Route;
use Dompdf\Dompdf;

class HomeController extends AbstractController
{

    private $repoBien,
            $repoClient,
            $repoLigneFacture,
            $repoLocation,
            $repoFacturation;


    public function __construct(BienRepository $bienRepository, ClientRepository $clientRepository, FacturationRepository $facturationRepository, LigneFacturationRepository $ligneFacturationRepository, LocationRepository $locationRepository)
    {
        $this->repoBien = $bienRepository;
        $this->repoClient = $clientRepository;
        $this->repoFacturation = $facturationRepository;
        $this->repoLigneFacture = $ligneFacturationRepository;
        $this->repoLocation = $locationRepository;
    }


    /**
     * @Route("/home", name="home", methods={"GET","POST"})
     */
    public function index(): Response
    {
        $form = $this->createForm(BienType::class);

        return $this->render('home/index.html.twig', [
            'controller_name' => 'HomeController',
            'form' => $form->createView()
        ]);
    }

    /**
     * @Route("/listebiensf", name="lbf", methods={"GET","POST"})
     */

     public function filtreBien(Request $request, PaginatorInterface $paginator) {

         $typeBien = $request->get('bien')["Type"];

        $biens =$paginator->paginate($this->repoBien->findBytype($typeBien),$request->query->getInt('page',1),9);

        

        return $this->render('home/filtreBien.html.twig', [
                'typeBien' => $typeBien,
                'biens' => $biens
        ]);
     }

    /**
     * @Route("/listbiens", name="lb")
     */

     public function listBien(BienRepository $bienRepository, PaginatorInterface $paginator, Request $request): Response
     {
        $results = $paginator->paginate($bienRepository->findAll(),$request->query->getInt('page',1),9);
        
         return $this->render('home/listBien.html.twig', [
            'results' => $results,
         ]);
     }

     /**
      * @Route("/listbiens/{id}", methods={"GET","POST"}, name="det")
      * 
      */

     public function detailBook(int $id, Request $request, MailerInterface $mailer, ClientRepository $client)
     {

        define("piscineEnfant", 1  );
        define("piscineAdulte", 1.5  );
        define("TaxeAdulte", 0.35  );
        define("TaxeEnfant", 0.60  );
        


         $location = new Location();
         $facture = new Facturation();
         $ligneFactureTaxe = new LigneFacturation();
         $ligneFacturePiscine = new LigneFacturation();
         $ligneFactureBienPrix = new LigneFacturation();
         $dompdf = new Dompdf();

         
         $lastfacture = $this->repoFacturation->findLastFacture();
         $bien = $this->repoBien->find($id);
       

         $location->setBien($bien);

         $form = $this->createForm(LocationType::class, $location);
         $form->handleRequest($request);
         
        
         if ($form->isSubmitted() && $form->isValid()) {
    
             $facture->setClient($location->getClient())
             ->setDateFacturation(new DateTime("now"))
             ->setNumeroIdentification( ($lastfacture) ? ($lastfacture[0]->getNumeroIdentification()) + 1 : 1)
              ;

             $ligneFactureTaxe->setFacture($facture)
             ->setLibelle("Taxe")
             ->setReference(1)
             ->setPrix(strtotime($location->getDateArrive()->diff($location->getDateDepart())->format("Y-M-D")) * $location->getNbrEnfant() * TaxeEnfant + $location->getNbrAdulte() * TaxeAdulte);

             $ligneFacturePiscine->setFacture($facture)
             ->setLibelle("Piscine")
             ->setReference(2)
             ->setPrix(strtotime($location->getDateArrive()->diff($location->getDateDepart())->format("Y-M-D")) * $location->getNbrJourPiscineAdulte() * piscineAdulte + $location->getNbrJourPiscineEnfant() * piscineEnfant);

             $ligneFactureBienPrix->setFacture($facture)
             ->setLibelle("Prix du bien")
             ->setReference(3)
             ->setPrix(($location->getDateArrive()->diff($location->getDateDepart())->format("%a")) * $location->getBien()->getType()->getPrix());
               
             dump(($location->getDateArrive()->diff($location->getDateDepart())->format("%a")) * $location->getBien()->getType()->getPrix());
           
             $entityManager = $this->getDoctrine()->getManager();
             $entityManager->persist($location);
             
             $entityManager->persist($ligneFactureTaxe);
             $entityManager->persist($ligneFacturePiscine);
             $entityManager->persist($facture);
             $entityManager->persist($ligneFactureBienPrix);
             $entityManager->flush();

              $html = $this->render("home/factureEmail.html.twig", [
                  'bien' => $bien,
                  'client' => $client->findLastUser(),
                  'location' => $location,
                  'facture' => $facture,
                  'ligneFactureBienPrix' => $ligneFactureBienPrix,
                  'ligneFacturePiscine' => $ligneFacturePiscine,
                  'ligneFactureTaxe' => $ligneFactureTaxe
              ]);

              $dompdf->loadHtml($html->getContent());
              $dompdf->render();
              $output = $dompdf->output();
              $publicDirectory = $this->getParameter('kernel.project_dir') . '/public/facture/';

              
            
              $Client = $client->findLastUser();
              $ClientNom = $Client[0]->getNom()? : $Client->getNom() ;
              $ClientPrenom = $Client[0]->getpreNom() ?:  $Client->getpreNom()  ;

              $pdffilepath = $publicDirectory . $ClientNom."_".$ClientPrenom."_facture.pdf";
              file_put_contents($pdffilepath,$output);

             

            $emailClient = $client->findLastUser();

             $email = (new Email())
             ->from(new Address('matthieu.roquigny.camping@gmail.com', 'Espadrille Volante Bot'))
             ->to($emailClient["0"]->getEmail())
             ->subject("Facture Reservation")
             ->attachFromPath($pdffilepath, $ClientNom."_".$ClientPrenom."_facture.pdf");

             
             $mailer->send($email);


             $entityManager->flush();



             return $this->redirectToRoute('detf');

         }

         return $this->render("bien/show.html.twig",[
             'biens' => $bien,
             'form' => $form->createView()
         ]);
     }

     /**
      * @Route("/facture/", methods={"GET","POST"}, name="detf")
      */

      public function getFacture (): Response {
            $facture = $this->repoFacturation->findLastFacture();
            $location = $this->repoLocation->findLastLocation();
            $client = $this->repoClient->findLastUser();
            $ligneFacture = $this->repoLigneFacture->findLastFacture();

            return $this->render("home/facture.html.twig", [
               //dump($ligneFacture),
                'client' => $client,
                'location' => $location,
                'facture' => $facture,
                'ligneFacture' => $ligneFacture
            ]);
      }
     
}

templates/home/_formReservation.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
{{ form_end(form) }}

templates/home/facture.html.twig
{% extends "base.html.twig" %}

{% block body %}
	<div class="container mt-5 mb-3">
		<div class="row d-flex justify-content-center">
			<div class="col-md-8">
				<div class="card">
					<div class="d-flex flex-row p-2">
						<img class= "pe-2" src="https://image.freepik.com/vecteurs-libre/dessines-main-camping-logo-templates_23-2147542188.jpg" width="150">
						<div class="d-flex flex-column">
							<span class="font-weight-bold">Facture Camping</span>
							{% for factureone in facture %}
								<small>n°{{factureone.numeroIdentification }}
								</small>
								<span>Date de facturation: {{factureone.dateFacturation|date("d/m/Y")}}</span>
							{% endfor %}
						</div>
					</div>
					<hr>
					<div class="table-responsive p-2">
						<table class="table table-borderless">
							<tbody>
								<tr class="add">
									<td>To</td>
									<td>From</td>
								</tr>
								<tr class="content">
									<td class="font-weight-bold">
										{% for oneclient in client %}
											{{oneclient.Nom ~ " " ~ oneclient.Prenom}}
											<br>{{oneclient.adresse}}</td>
									{% endfor %}
									<td class="font-weight-bold">
										{% for onelocation in location %}
											{{onelocation.Bien.Proprietaire.Nom}}
											<br>
											{{onelocation.Bien.Proprietaire.adresse}}</td>
									{% endfor %}
								</tr>
							</tbody>
						</table>
					</div>
					<hr>
					<div class="products p-2">
						<table class="table table-borderless">
							<tbody>
								<tr class="add">
									<td class="text-left">Reference</td>
									<td class="text-left">Description</td>
									<td class="text-center">Prix</td>
								</tr>
								{% for oneLigneFacture in ligneFacture %}

									<tr class="content">
										<td>{{oneLigneFacture.reference}}</td>
										<td>{{oneLigneFacture.libelle}}</td>
										<td class="text-center">{{oneLigneFacture.prix}}
											€</td>
									</tr>
								{% endfor %}
							</tbody>
						</table>
					</div>
					<hr>
					<div class="products p-2">
						<table class="table table-borderless">
							<tbody>
								<tr class="add">
									<td></td>
									<td></td>
									<td class="text-center">Total</td>
								</tr>
								<tr class="content">
									{% set total = 0 %}
									{% for oneLigneFacture in ligneFacture %}
										{% set total = total + oneLigneFacture.prix %}
									{% endfor %}
									<td></td>
									<td></td>
									<td class="text-center">{{total}}
										€</td>
								</tr>
							</tbody>
						</table>
					</div>
				</div>
			</div>
		</div>
	</div>
{%  endblock %}

templates/home/factureEmail.html.twig
{% extends "base.html.twig" %}

{% block body %}
	<div class="container mt-5 mb-3">
		<div class="row d-flex justify-content-center">
			<div class="col-md-8">
				<div class="card">
					<div class="d-flex flex-row p-2">
						<img src= "/public/images/facture/dessines-main-camping-logo-templates_23-2147542188.jpg" width="48">
						<div class="d-flex flex-column">
							<span class="font-weight-bold">Facture</span>
							<small>{{facture.numeroIdentification }}
							</small>
							<span>{{facture.dateFacturation|date("d/m/Y")}}</span>
						</div>
					</div>
					<hr>
					<div class="table-responsive p-2">
						<table class="table table-borderless">
							<tbody>
								<tr class="add">
									<td>To</td>
									<td>From</td>
								</tr>
								<tr class="content">
									<td class="font-weight-bold">
										{% for oneclient in client %}
											{{oneclient.Nom ~ " " ~ oneclient.Prenom}}
											<br>{{oneclient.adresse}}</td>
									{% endfor %}
									<td class="font-weight-bold">
										{{bien.Proprietaire.Nom}}
										<br>
										{{bien.Proprietaire.adresse}}</td>
								</tr>
							</tbody>
						</table>
					</div>
					<hr>
					<div class="products p-2">
						<table class="table table-borderless">
							<tbody>
								<tr class="add">
									<td>Description</td>
									<td>Days</td>
									<td>Prix</td>
								</tr>

								<tr class="content">
									<td class="text-left">{{ligneFactureTaxe.reference}}</td>
									<td class="text-left">{{ligneFactureTaxe.libelle}}</td>
									<td class="text-center">{{ligneFactureTaxe.prix}}</td>
								</tr>

								<tr class="content">
									<td class="text-left">{{ligneFactureBienPrix.reference}}</td>
									<td class="text-left">{{ligneFactureBienPrix.libelle}}</td>
									<td class="text-center">{{ligneFactureBienPrix.prix}}</td>
								</tr>

								<tr class="content">
									<td class="text-left">{{ligneFacturePiscine.reference}}</td>
									<td class="text-left">{{ligneFacturePiscine.libelle}}</td>
									<td class="text-center">{{ligneFacturePiscine.prix}}</td>
								</tr>

							</tbody>
						</table>
					</div>
					<hr>
					<div class="products p-2">
						<table class="table table-borderless">
							<tbody>
								<tr class="add">
									<td class="text-center">Total</td>
								</tr>
								<tr class="content">
									<td class="text-center">{{ligneFactureBienPrix.prix + ligneFacturePiscine.prix + ligneFactureTaxe.prix}}</td>
								</tr>
							</tbody>
						</table>
					</div>
				</div>
			</div>
		</div>
	</div>
{%  endblock %}

templates/home/filtreBien.html.twig
{% extends "base.html.twig" %}

{% block body %}
	<div class="jumbotron text-capitalize text-center">
		<h2>Liste édité à partir de
			{{ biens[0].Type}}</h2>
	</div>
	<div class="container">
		<div class="row">
			<div class="col">
				<div class="row d-flex flex-row justify-content-center">
					{% for bien in biens %}
						<div class="card mb-4 me-4" style="width: 30%;">
							<div class="card-body">
								<h4 class="card-title">{{ bien.Type }}</h4>
								<h4 class="card-title">{{ bien.Proprietaire }}</h4>

								{#            <a href="/detail/{book.id}" class="btn btn-primary btn-sm">détail</a>#}
								{# <a href="{{ path('det', { id: book.id } ) }}" class="btn btn-primary btn-sm">détail</a> #}
								<img class="card-img" src="{{ vich_uploader_asset(bien, 'imageFile') }}"></img>
						</div>
						<div class="card-footer">
							<a class="btn btn-primary" href="{{path('det',{id: bien.id})}}" role="button">Détail</a>
						</div>

					</div>
				{% endfor %}
				<div>
					<div class=" d-flex justify-content-end">
						{{ knp_pagination_render(biens) }}
					</div>
                    <div>
                        <a href="{{path("home")}}">home</a>
                    </div>
				</div>

			</div>

		</div>
	</div>


</div>{% endblock %}{% block title %}Bienvenue{% endblock %}

templates/home/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Hello HomeController!
{% endblock %}

{% block body %}

	<div class="reservation_home">
		<div class="imgback">
			<div class="titre_home"></div>
		</div>
		<div class="form_home">
			{{ form_start(form) }}
			{{ form_widget(form) }}			
			{{ form_end(form) }}
		</div>
	</div>

	<a class= "text-white" href="{{path('lb')}}">Liste de tous les biens !</a>


{% endblock %}

{% block footer %}{% endblock %}

templates/home/listBien.html.twig
{% extends "base.html.twig" %}

{% block body %}
	<div class="jumbotron text-capitalize text-center">
		<h2>Liste des Biens</h2>
	</div>
	<div class="container">
		<div class="row">
			<div class="col">
				<div class="row d-flex flex-row justify-content-center">
					{% for result in results %}
						<div class="card mb-4 me-4" style="width: 30%;">
							<div class="card-body">
								<h4 class="card-title">{{ result.Type }}</h4>
								<h4 class="card-title">{{ result.Proprietaire }}</h4>

								{#            <a href="/detail/{book.id}" class="btn btn-primary btn-sm">détail</a>#}
								{# <a href="{{ path('det', { id: book.id } ) }}" class="btn btn-primary btn-sm">détail</a> #}
								<img class="card-img" src="{{ vich_uploader_asset(result, 'imageFile') }}"></img>
						</div>
						<div class="card-footer">
							<a class="btn btn-primary btn-primary" href="{{path('det',{id: result.id})}}" role="button">Détail</a>
						</div>

					</div>
				{% endfor %}
				<div class=" d-flex justify-content-between">
					<div>
						<a class="btn btn-dark text-white" href="{{path("home")}}">home</a>
					</div>
					<div>
						{{ knp_pagination_render(results) }}
					</div>

				</div>
			</div>

		</div>
	</div>


</div>{% endblock %}{% block title %}Bienvenue{% endblock %}

templates/home/newReservation.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Location{% endblock %}

{% block body %}
    <h1>Information de réservation</h1>

    {{ include('home/_formReservation.html.twig') }}

{% endblock %}